function Lloo = get_Lloo(gp_train, kfun, hyp)

input = gp_train.input;
output = gp_train.output;
nr_data = gp_train.nr_data;
mean_output = mean(output);
mz_output = output - repmat(mean_output, nr_data, 1);


K = kfun(input, input, hyp);
invK = inv(K);
invKy = K \ mz_output;
Lloo = 0; 
for i = 1:nr_data
    yi = mz_output(i, :);
    mui = yi - invKy(i)/invK(i, i);
    sig2i = 1/invK(i, i);
    val = -0.5*log10(sig2i) - (yi-mui)*(yi-mui)/2/sig2i - 0.5*log(2*pi);
    % val = (yi-mui)*(yi-mui)/2/sig2i - 0.5*log(2*pi);
    % val = (yi-mui)*(yi-mui)/2;
    Lloo = Lloo + val;
end

