function meas_struct = get_meas_field(field_struct, stage_struct, nr_meas)

meas_struct.nr_data = nr_meas;

x_rand = stage_struct.xmin + (stage_struct.xmax-stage_struct.xmin)*rand(nr_meas, 1);
y_rand = stage_struct.ymin + (stage_struct.ymax-stage_struct.ymin)*rand(nr_meas, 1);
z_rand = zeros(nr_meas, 1);
for zi = 1:nr_meas
    z_rand(zi) = interp2(field_struct.xgrid, field_struct.ygrid, field_struct.zdata, ...
            x_rand(zi), y_rand(zi) );
end

meas_struct.input = [x_rand y_rand];
meas_struct.output = z_rand;
