function hgp_result = hgpr(hgp_struct, x_test)

nr_test = size(x_test, 1);
nr_data = size(hgp_struct.output, 2);

hgp_result.mean = zeros(nr_test, nr_data);
hgp_result.var  = zeros(nr_test, 1);

for i = 1:nr_test
    % Comptute kernel vector
    lev_default = 1;
    k_vector = hgp_struct.kernel_test(x_test(i, :), hgp_struct.input ...
        , lev_default, ones(nr_data, 1));
    
    % 1. Predictive mean
    hgp_result.mean(i, :) = k_vector*hgp_struct.invKmeanzeroY ...
        + repmat(hgp_struct.mean_output, 1, 1);
    
    % 2. Predictive variance
    hgp_result.var(i) = abs(hgp_struct.kernel_test(x_test(i, :), x_test(i, :) ...
        , lev_default, lev_default) ...
        - k_vector*hgp_struct.invK*k_vector');
end

