function K = kernel_lev(X1, X2, lev1, lev2, hyp, fun_lev)
%
% Leveraged kernel function
%
g2 = hyp.g2; 
w2 = hyp.w2;
l2 = hyp.l2;

nr_X1 = size(X1, 1);
nr_X2 = size(X2, 1);
K_lev = zeros(nr_X1, nr_X2);
for i = 1:nr_X1
    for j = 1:nr_X2
        lev_i = lev1(i);
        lev_j = lev2(j);
        
        % K_lev(i, j)  = kernel_lhs(lev_i, lev_j);
        if nargin == 5
            K_lev(i, j)  = 1 - abs(lev_i - lev_j);
        else
            K_lev(i, j)  = fun_lev(lev_i ,lev_j);
        end
    end
end

K_se = kernel_se(X1, X2, hyp);

K = K_lev.*K_se;

