function fig = plot_two_fields(field_struct, field1, field2, meas_struct, str1, str2)

fig = figure(); scrsz = get(0,'ScreenSize'); colormap jet;
set(fig,'Position', [0.2*scrsz(3),0.2*scrsz(4),0.2*scrsz(3),0.534*scrsz(4)]);
subaxes(fig, 2, 1, 1, 0.2, 0.1); hold on;
pcolor(field_struct.xgrid, field_struct.ygrid, field1); 
axis equal; xlabel('X'); ylabel('Y');
colorbar;
title([str1], 'FontSize', 15);

subaxes(fig, 2, 1, 2, 0.2, 0.1);
pcolor(field_struct.xgrid, field_struct.ygrid, field2); hold on
plot(meas_struct.input(:, 1), meas_struct.input(:, 2), 'ko', 'MarkerFaceColor', 'w');
axis equal; xlabel('X'); ylabel('Y');
colorbar;
title([str2], 'FontSize', 15);